# Composants discrets : R, L et C

## Résistance
- R : `--^v^v^v--`
- s'oppose au passage du courrant

Résistance d'un fil :
```
       L
R = p ---
       S
```
avec :
- R : résistance
- p : matériau
- L : longueur
- S : surface

## Condensateur

- C : `--||--`
- se comporte comme une réserve d'énergie, bloque le passage d'un courant continu.

```
        S
C = e0 ---
        e
```
avec :
- C :  capacité
- e0 : permissivité diélectrique
- e :  a distance entre les armatures
- S :  la surface des armatures

## Bobine

- L : `--OOO--`
- se comporte comme une résistance nulle en courant continue
  et comme une résistance forte en courant alternatif, proportionnellement à la fréquence.

```
    ||  1   ||
Z = || ---- ||
    ||  cw  ||
```
avec :
- Z : ?
- ...

## Transistor

Intérupteur électriquement controllé, peut être utilisé comme porte logique ET.

### MOS (Metal Oxyde Semiconductor)

```
       __________ Source
      /    ______ Générateur
     /    /    __ Drain
    /    /    /

   S    G    D
   |    |    |
 +-|----|----|-+
 | O ======= O |
 +------|------+
        |
        T

         \_____ Terre
```

Quand le circuit `Générateur -> Terre` charge la plaque,
elle devient conductrice et ferme le circuit `Source -- Drain`.

> Note :
> Il est possible de piloter de grandes tensions sur S -- D
> avec une faible tension dans G -- T.
>
> Donc, le système est très sensible aux parasites.

### CMOS (Complementary MOS)

Les transistors MOS peuvent donc être modélisés en fonctionnement Bloqué / Saturé,
comme des interrupteurs 'idéaux' tel que :

#### Type N

```
       d
       |
     +-+
g --||
     +-+
       |
       s
```

avec :
- Vgs =   0 -> `d - - s`
- Vgs = Vdd -> `d --- s`

#### Type P

```
       s
       |
     +-+
g -o||
     +-+
       |
       d
```

avec :
- Vgs =    0 -> `s --- d`
- Vgs = -Vdd -> `s - - d`

### Fonctions logiques

#### Porte NOT

Avec le montage :

```
1 ------+-- 1
        |
    .-o||
    |   |
E ->+   +-> S
    |   |
    `--||
        |
0 ------+-- 0
```

- lorsque E = 0
	- le MOS P (haut) est fermé
	- le MOS N (bas)  est ouvert
	- la tension S = 1

- lorsque E = 1
	- le MOS P (haut) est ouvert
	- le MOS N (bas)  est fermé
	- la tension S = 0

On a donc :

```
+---+---+
| E | S |
+---+---+
| 0 | 1 |
| 1 | 0 |
+---+---+
```

> Note :
> La tension E est évacuée vers la masse et le circuit ne chauffe pas.

> Note :
> Physiquement, le MOS N est sensible à l'abscence de charge.
> Il est donc plus rapide que le MOS P qui est basé sur la présence de charge.

#### Porte NAND

```
1 ------+------------ 1
        |
    .-o||
    |   |
A ->+   +---------.
    |   |         |
    `--||     .-o||
        |     |   |
B ----- | --->+   +-> S
        |     |   |
        |     `--||
        |         |
0 ------+---------+-- 0
```

Composé de deux portes NOT, la sortie de l'une est l'entrée de l'autre.

### Porte AND

```
1 ------+-------------------+-- 1
        |                   |
    .-o||                   |
    |   |                   |
A ->+   +---------.         |
    |   |         |         |
    `--||     .-o||     .-o||
        |     |   |     |   |
B ----- | --->+   +---->+   +-> S
        |     |   |     |   |
        |     `--||     `--||
        |         |         |
0 ------+---------+---------+-- 0
```

Composé d'une porte NAND dont la sortie est l'entrée d'une porte NOT.
